// *************************************
// ** ZXpandMouse.h                   **
// ** Class Definitions               **
// *************************************


class MouseRptParser : public MouseReportParser
{
	protected:
		void OnMouseMove		(MOUSEINFO *mi);
		void OnLeftButtonUp		(MOUSEINFO *mi);
		void OnLeftButtonDown	(MOUSEINFO *mi);
		void OnRightButtonUp	(MOUSEINFO *mi);
		void OnRightButtonDown	(MOUSEINFO *mi);


	public:
		// Keep track of last mouse movement by direction
		// Up, Down, Left, Right, Fire
		long MovedLastMills[5];

};
void MouseRptParser::OnMouseMove(MOUSEINFO *mi)
{

	if(mi->dY != 0){
		if(mi->dY < -1){
			// Serial.println(" UP");
			// Get milliseconds since turn on. Used to comapre times for debounce
			MovedLastMills[0] = millis();
		} else if(mi->dY > 1){
			//Serial.println(" DOWN");
			// Get milliseconds since turn on. Used to comapre times for debounce
			MovedLastMills[1] = millis();
		}
	}

	if(mi->dX != 0){
		if(mi->dX < -1){
			//Serial.println(" LEFT");
			MovedLastMills[2] = millis();
		} else if(mi->dX > 1){
			//Serial.println(" RIGHT");
			MovedLastMills[3] = millis();
		}
	}

};
// Simple button press
void MouseRptParser::OnLeftButtonUp	(MOUSEINFO *mi)
{
    MovedLastMills[4] = false;
};
void MouseRptParser::OnLeftButtonDown	(MOUSEINFO *mi)
{
    MovedLastMills[4] = true;
};
void MouseRptParser::OnRightButtonUp	(MOUSEINFO *mi)
{
    MovedLastMills[4] = false;
};
void MouseRptParser::OnRightButtonDown	(MOUSEINFO *mi)
{
    MovedLastMills[4] = true;
};


